﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace ConsoleEnums
{
    /// <summary>
    /// Методы класса позволяют тестировать
    /// перечисления - создавать и обрабатывать
    /// объекты перечислений, определенных в проекте
    /// </summary>
    class Testing
    {
        /// <summary>
        /// Создание объектов перечислений,
        /// присваивание значений и вывод на печать
        /// </summary>
        public void TestEnum()
        {
            const string COLOR_EQUAL =
                "Цвета совпадают!";
            const string COLOR_DIFFERENT =
                "Цвета не совпадают!";
            const string ENUM_RAINBOW =
                "Цвета перечисления Rainbow:";

            Rainbow color = new Rainbow();
            //MyColors color1 = MyColors(MyColors.blue);
            MyColors color1 = MyColors.white;
            TwoColors color2;
            color2 = TwoColors.white;
            Console.WriteLine("цвет1 = {0}, цвет2 = {1}",
                color1, color2);

            //if(color1 != color2) color2 = color1;
            if (color1.ToString() == color2.ToString())
                Console.WriteLine(COLOR_EQUAL);
            else Console.WriteLine(COLOR_DIFFERENT);
            
            Rainbow color3;
            color3 = (Rainbow)4;
            color1 = MyColors.blue;
            Console.WriteLine("цвет1 = {0}, цвет2 = {1}",
                color1, color3);
            if (color3 == Rainbow.голубой) 
                Console.WriteLine(COLOR_EQUAL);
            else Console.WriteLine(COLOR_DIFFERENT);

            Console.WriteLine(ENUM_RAINBOW);
            for (int num = 0; num < 10; num++)
            {
                color = (Rainbow)num;
                Console.WriteLine(color.ToString());
            }

            Sex who = Sex.man;
            Days first_work_day = (Days)(long)1;
           
            Console.WriteLine("who={0}, first_work_day={1}",
                who, first_work_day);
        }
        /// <summary>
        /// тестирование перечисления в разборе случаев
        /// </summary>
        public void TestProfession()
		{
			Person pers1 = new Person ("Петров");
			pers1.Prof = Profession.teacher;
			pers1.Analysis();
		}
        public void TestStatus()
        {
            Person pers = new Person("Кузнецов");
            pers.Age = 5;
            Console.WriteLine("возраст = {0}, статус = {1}",
                pers.Age, pers.GetStatus);
            pers.Age = 20;
            Console.WriteLine("возраст = {0}, статус = {1}",
                pers.Age, pers.GetStatus);
            pers.Age = 35;
            Console.WriteLine("возраст = {0}, статус = {1}",
                pers.Age, pers.GetStatus);
        }
        /// <summary>
        /// Создание массива Person из 5 элементов,
        /// обладающих набором свойств Dream_Properties
        /// </summary>
        /// <returns>массив объектов Person</returns>
        Person[] CreatePersonsWithProperties()
        {
            Person[] persons = new Person[5];
            persons[0] = new Person("Петров");
            persons[0].Properties = Dream_Properties.умный |
                Dream_Properties.добрый;
            persons[1] = new Person("Фролов");
            persons[1].Properties = Dream_Properties.умный |
                Dream_Properties.богатый;
            persons[2] = new Person("Климов");
            persons[2].Properties = Dream_Properties.богатый |
                Dream_Properties.добрый;
            persons[3] = new Person("Карпов");
            persons[3].Properties = Dream_Properties.умный;
            persons[4] = new Person("Иванов");
            persons[4].Properties = Dream_Properties.добрый;
            return persons;
        }
        
        /// <summary>
        /// Поиск в массиве persons 
        /// персоны со свойствами, заданными образцом pattern
        /// </summary>
        /// <param name="persons"></param>
        /// <param name="pattern"></param>
        /// <returns></returns>
        Person FindOnePerson(Person[] persons, 
            Dream_Properties pattern)
        {
            foreach (Person person in persons)
                if ((person.Properties & pattern) == pattern)                
                    return person;
            return null;    
        }
        public void TestScale()
        {
            const string NOT_EXIST =
                " К сожалению, умные, добрые и " +
                "одновременно богатые встречаются крайне редко!";
            Person[] persons = CreatePersonsWithProperties();
            Person person;
            Dream_Properties pattern = Dream_Properties.богатый |
                Dream_Properties.добрый | Dream_Properties.умный;
            string strPattern = GetStrFromDreamObject(pattern);
            Console.WriteLine ("pattern = " + strPattern); 
            person = FindOnePerson(persons, pattern);
            if (person == null)
                Console.WriteLine(NOT_EXIST);
            else 
                Console.WriteLine(person.Fam + " - " +
                    GetStrFromDreamObject(person.Properties));
            pattern = Dream_Properties.добрый | Dream_Properties.умный;
            strPattern = GetStrFromDreamObject(pattern);
            Console.WriteLine("pattern = " + strPattern);
            person = FindOnePerson(persons, pattern);
            if (person == null)
                Console.WriteLine(NOT_EXIST);
            else
                Console.WriteLine(person.Fam + " - " +
                    GetStrFromDreamObject(person.Properties));
        }
        /// <summary>
        /// Аналог метода ToString для перечислений
        /// </summary>
        /// <param name="item">объект перечисления</param>
        /// <returns>строка со свойствами объекта</returns>
        string GetStrFromDreamObject(Dream_Properties item)
        {
            const int PROPERTIES_COUNT = 3;
            string str = "";
            int k = 1;
            for (int i = 1; i <= PROPERTIES_COUNT; i++)
            {
                if((k & (int)item) == k) 
                str += (Dream_Properties)k + " ";
                k <<= 1;
            }            
            return str;
        }
        /// <summary>
        /// Один объект и много запросов
        /// </summary>
        public void TestQueries()
        {
            Person person;
            Dream_Properties pattern;
            person = new Person("Петров");
            person.Properties = Dream_Properties.добрый |
                Dream_Properties.умный;
            string str = GetStrFromDreamObject(person.Properties);
            Console.WriteLine("Свойства персоны: " + str);
            
            pattern = Dream_Properties.богатый | 
                Dream_Properties.добрый;            
            str = GetStrFromDreamObject(pattern);
            Console.WriteLine("Свойства образца: " + str);

            Dream_Properties temp = person.Properties & pattern;
            bool query1, query2, query3, query4, query5;
            // все свойства образца
            query1 = temp == pattern;

            // ни одно из свойств образца
            query2 = (~person.Properties & pattern) == pattern;

            // некоторые свойства образца
            query3 = temp > 0;

            // некоторые, но не все свойства образца
            query4 = temp > 0 && temp < pattern;

            // только свойства образца
            query5 = (temp == pattern) && 
               ( (person.Properties & ~pattern) == 0);

            Console.WriteLine("результаты запросов: ");
            Console.WriteLine(" query1(все свойства) = {0}", query1);
            Console.WriteLine(" query2(ни одного из свойств) = {0}",
                query2);
            Console.WriteLine(" query3(некоторые из свойств) = {0}",
                query3);
            Console.WriteLine(" query4(некоторые, но не все свойства) = {0}",
                query4);
            Console.WriteLine(" query5(только свойства образца) = {0}",
                query5);            
        }
        /// <summary>
        /// Тестирование процесса приема на работу 
        /// </summary>
        public void TestJob()
        {
            Prog_Properties pattern = Prog_Properties.C_sharp |
                Prog_Properties.Web;
            Console.WriteLine("Требования, заданные образцом:" +
                " Знание языка С# и Web технологии");

            int n = 5;
            Job mys = new Job(n);
            mys.FormCands();
            Prog_Properties[] cand = mys.GetCands();
            string[] strCand = mys.GetStrCands();
            for (int i = 0; i < n; i++)
            {
                Console.WriteLine("Свойства кандидата[{0}] - {1}",
                    i, cand[i]);
                Console.WriteLine(strCand[i]);
            }

            mys.Pattern = pattern;
            ArrayList result;
            result = mys.CandsHavePat();
            Console.WriteLine("Кандидаты, имеющие заданные свойства:");
            foreach (string pretender in result)
                Console.WriteLine(pretender);

            result = mys.CandsHaveNotAllPat();
            Console.WriteLine("Кандидаты, не имеющие всех заданных свойств:");
            foreach (string pretender in result)
                Console.WriteLine(pretender);

            result = mys.CandsHaveSomePat();
            Console.WriteLine("Кандидаты, имеющие некоторые заданные свойства:");
            foreach (string pretender in result)
                Console.WriteLine(pretender);

            result = mys.CandsHaveOnlyPat();
            Console.WriteLine("Кандидаты, имеющие только заданные свойства:");
            foreach (string pretender in result)
                Console.WriteLine(pretender);
        }
    }
}
